/*
Author     :  AA-Team - http://themeforest.net/user/AA-Team
*/
// Initialization and events code for the app
sp_admin = (function ($) {
    "use strict";

    // public
    var debug_level = 0,
        maincontainer = null,
        $action_status = null,
        notices_main = null,
        loading = null,
        notices_opt = {};
    
	// init function, autoload
	(function init() {
		
		// load the triggers
		$(document).ready(function(){
			maincontainer = $(".sp_iw");
			$action_status = maincontainer.find(".sp-action-status.sp-message");

            notices_main = $("#sp-admin-mainnotices");

			triggers();

			loading = $(".sp_iw-loader");

			fix_content_width();

			replace_emails_recipient_shown();
			
		});

		$(window).resize(function(){
			fix_content_width();
		});
	})();

	function update( data )
	{
		maincontainer.find(".sp_iw-loader").show();
		
		maincontainer.find(".sp_iw-loader").find('span').html('');
		$.ajax({
			url: ajaxurl,
			data: $.extend(
				{
					_ajax_custom_list_nonce: $('#_ajax_custom_list_nonce').val(),
					action: $("#ajaxid").val()
				},
				data
			),
			// Handle the successful result
			success: function( response ) {

				// WP_List_Table::ajax_response() returns json
				var response = $.parseJSON( response );

				// add the requested rows
				if ( response.rows.length )
					maincontainer.find('#the-list').html( response.rows );
					
				// update column headers for sorting
				if ( response.column_headers.length )
					maincontainer.find('thead tr, tfoot tr').html( response.column_headers );
					
				// update pagination for navigation
				if ( response.pagination.bottom.length )
					maincontainer.find('.tablenav.top .tablenav-pages').html( $(response.pagination.top).html() );
					
				if ( response.pagination.top.length )
					maincontainer.find('.tablenav.bottom .tablenav-pages').html( $(response.pagination.bottom).html() );

				// init back our event handlers
				triggers();
				
				// hide the loader
				maincontainer.find(".sp_iw-loader").fadeOut(250);
			}
		});
	}

	function replace_emails_recipient_shown() {
		$('.wc_emails_wrapper').each(function(){
			$(this).find('.wc-email-settings-table-name').each(function(){
				if( $(this).find('a').text() == 'Image Review Approved (with coupon)' || 
					$(this).find('a').text() == 'Image Review Approved (without coupon)' ||
					$(this).find('a').text() == 'Invite Customer To Review The Product'
				){
					$(this).next().next().text('Customer');
				}
				else if( $(this).find('a').text() == 'Pending Image Review' ){
					$(this).next().next().text('Admin(s)');
				}

			});
		});
	}
	
	function __query( query, variable )
	{
		var vars = query.split("&");
		for ( var i = 0; i <vars.length; i++ ) {
			var pair = vars[ i ].split("=");
			if ( pair[0] == variable )
				return pair[1];
		}
		return false;
	}
	
	function fix_content_width()
	{
		maincontainer.css({
			'height': ( $("#wpwrap").height() - 70 )
		});
	}
	
	function launch_amazon_search( that, search_by )
	{
		maincontainer.find(".sp_iw-loader").show();
		
		var form = that.parents("form").eq(0),
			paged = that.data('paged');
		
		if( parseInt(paged) == 0 ){
			paged = 1;
		}
		
		$.ajax({
			url: ajaxurl,
			dataType: "json",
			method: 'post',
			data: {
				action: 'sp_launch_amz_search',
				search_by: search_by,
				keyword: form.find('input[name="keyword"]').val(),
				node: form.find('select[name="node"]').val(),
				asin: form.find('input[name="product[ASIN]"]').val(),
				paged: paged
			},
			// Handle the successful result
			success: function( response ) {
				
				if( response.status == 'valid' ) {

    				if( search_by != "asin" ){
    					$("#sp-dropdown-amazon-selector").html( response.html ).show();
    				}

    				else if ( search_by == "asin" ){
    					$(".sp-product-details").each(function(){
    						var form = $(this);
    						
    						form.find('input[name="product[Title]"]').val( response.product.Title );
    						form.find('input[name="product[Brand]"]').val( response.product.Brand );
    						form.find('input[name="product[DetailPageURL]"]').val( response.product.DetailPageURL );
    						form.find('input[name="product[SmallImage]"]').val( response.product.SmallImage );
    						form.find('input[name="product[Binding]"]').val( response.product.Binding );
    						form.find('input[name="product[ListPrice]"]').val( response.product.ListPrice );
    						form.find('input[name="product[OfferSummary]"]').val( response.product.OfferSummary );
    					});
    				}
				} else {
				    $action_status.html( response.html )
				        .removeClass('sp-success').addClass('sp-error')
				        .show();
				}
				
				// hide the loader
				maincontainer.find(".sp_iw-loader").fadeOut(250);
			}
		});
	}


    /* BEGIN aa-framework */
    function make_tabs()
    {
    	function show_tab_elements( link, form, that )
    	{
    		var link_name = link.find("a").attr("href").replace("#", "");

    		// hide all elements
    		form.find( ".sp-form-row:not(." + ( link_name ) + "), .sp-message:not(." + ( link_name ) + ")" ).hide();

    		var cc = 0;
    		form.find( ".sp-form-row." + link_name + ", .sp-message." + link_name ).each(function(){
    			var that = $(this);
    			
    			that.show();

    			if( cc % 2 == 0 ){
    				that.addClass("sp-even");
    			}

    			if( cc % 1 == 0 ){
    				that.addClass("sp-odd");
    			}

    			cc++;
    		});

    		that.find(".on").removeClass("on");
    		link.addClass("on");
    	}

		maincontainer.find(".sp-settings-tabs").each(function(){
			var that = $(this),
				form = that.parents("form").eq(0),
				link = that.find("li").eq(0);

			show_tab_elements( link, form, that );

			that.on('click', 'li a', function(e){
				e.preventDefault();
				var link = $(this).parent("li");
				
				show_tab_elements( link, form, that );
			});
       });
    }
    
    
    function saveOptions($btn)
    {
        var theForm         = $btn.parents('form').eq(0),
            value           = $btn.val(),
            statusBoxHtml   = theForm.find('div#sp-status-box');

        // replace the save button value with loading message
        $btn.val('saving setings ...').removeClass('green').addClass('gray');
        
        theForm.submit();
        
        // replace the save button value with default message
        $btn.val( value ).removeClass('gray').addClass('green');
    }
	
	function build_oauth_url( client_id )
	{
		var oauth_container = $(".sp-tmdb-auth-box"),
			btn 			= oauth_container.find('#sp-tmdb-auth-button'),
			redirect_url	= oauth_container.find("input[name='redirect-url']").val(),
			tmdb_url		= 'https://api.tmdb.com/authorization?response_type=code&client_id={client_id}&redirect_uri={redirect_url}';
		
		var oauth_url = tmdb_url.replace( "{client_id}", client_id );
			oauth_url = oauth_url.replace( "{redirect_url}", redirect_url );
		
		btn.attr("href", oauth_url); 
	}
	
	function same_height( $elms )
	{
		$elms.each(function(){
			var row 		= $(this),
				maxHeight 	= 0,
				childs 		= row.find(">div .sp_iw-dashboard-in-box-content");

			childs.each(function(){
				var that = $(this),
					height = that.height();

				if( maxHeight <= height ){
					maxHeight = height;
				}
			});
			childs.height( maxHeight );
		});
	}

	function font_preview() 
	{
		function change_font( preview_elm ) {
			var that = preview_elm,
				pair_element = that.parents('.sp-form-item:first').find('select'),
				pair_value = pair_element.val(),
				google_font_url;
				// custom font
				if( pair_value == 'Bebas Neue Bold' ){
					google_font_url = sp_custom_font_path + '/bebasneuebold/font.css' ;
				}
				else {
					google_font_url = "http://fonts.googleapis.com/css?family=" + pair_value;
				}

			console.log( google_font_url );
			// step 1, load into DOM the spreadsheet
			$("head").append("<link href='" + ( google_font_url ) + "' rel='stylesheet' type='text/css'>");
			
			// step 2, print the font name into preview with inline font-family
			that.html( "<span style='font-family: " + ( pair_value ) + "'>Grumpy wizards make toxic brew for the evil Queen and Jack.</span>" );
		};
		
		$(".sp-font-preview").each(function(){
			var that = $(this),
				pair_element = that.parents('.sp-form-item:first').find('select');

			change_font( that );

			pair_element.change(function(e) {
				var preview = $(this).parents('.sp-form-item:first').find('.sp-font-preview');
				change_font( preview );
			});
		});
	};

	function register_plugin( that )
	{
		var form = that.parents('form').eq(0);

		loading.show();
		var data = {
            'action'	: 'sp_register',
			'params'	: form.serialize()
       	};
       	
		$.post(ajaxurl, data, function (response) {
			
			if( response.status == 'valid' ){
				location.reload();
			}
			else {
				var formContainer = form.parent('.sp_iw-dashboard-in-box-content');
				formContainer.text('');
				formContainer.append('<p>Invalid IPC. Please retry</p>');
			}

			loading.hide();
			
        }, 'json');
	}

	function user_get_charts() 
	{
		$('#sp-user-chart').each(function() {
			var that = $(this);

			$.ajax({
				url: ajaxurl,
				dataType: "json",
				method: 'post',
				data: {
					action: 'sp_get_user_chart',
					user: $(this).data('user')
				},
				// Handle the successful result
				success: function( response ) {
					if( response.status == 'valid' && !$.isEmptyObject( response.data ) ){

						google.charts.load('current', {'packages':['line']});
						google.charts.setOnLoadCallback(drawChart);

						function drawChart() {
							var responseData = response.data;

							// Create the data table.
							var data = new google.visualization.DataTable();

							data.addColumn('string', 'Date');
      						data.addColumn('number', 'No of Reviews');

							responseData.forEach(function(entry) {
								data.addRow([entry['post_date'], parseInt(entry['reviews_nb'])]);
							});

							var newData = google.visualization.data.group(data, [{
						        column: 0,
						        type: 'Date'
						    }], [{
						        column: 1,
						        label: 'No of Reviews',
						        aggregation: google.visualization.data.sum,
						        type: 'number'
						    }]);
							
							var options = {
								chart: {
									title: 'No. of Image Reviews per User by Date',
									subtitle: 'for your products'
								},
								width: 900,
								height: 500
							};

							var chart = new google.charts.Line(document.getElementById('sp-user-chart'));

							chart.draw(newData, google.charts.Line.convertOptions(options));
						}
					}
					else {
						that.text('No statistics for this product.');
					}
				}  
			});
		});
	}

	function registerResize(f) {
	    $(window).resize(function() {
	        clearTimeout(this.resizeTimeout);
	        this.resizeTimeout = setTimeout(function() {
	            var oldOverflow = document.body.style.overflow;
	            document.body.style.overflow = "hidden";
	            var currHeight = $(window).height(),
	                currwidth = $(window).width();
	            document.body.style.overflow = oldOverflow;

	            var prevUndefined = (typeof this.prevHeight === 'undefined' || typeof this.prevwidth === 'undefined');
	            if (prevUndefined || this.prevHeight !== currHeight || this.prevwidth !== currwidth) {
	                this.prevHeight = currHeight;
	                this.prevwidth = currwidth;

	                f(currHeight, currwidth);
	            }
	        }, 200);
	    });
	    $(window).resize(); // initialize
	}

	

	function product_get_charts() 
	{
		$('#sp-product-chart').each(function() {
			var that = $(this);

			$.ajax({
				url: ajaxurl,
				dataType: "json",
				method: 'post',
				data: {
					action: 'sp_get_product_chart',
					product: $('input#post_ID').val()
				},
				// Handle the successful result
				success: function( response ) {
					if( response.status == 'valid' && !$.isEmptyObject( response.data ) ){


						that.css('height', '550px');

						google.charts.load('current', {'packages':['line']});
						google.charts.setOnLoadCallback(drawChart);

						function drawChart() {
							var responseData = response.data;

							// Create the data table.
							var data = new google.visualization.DataTable();

							data.addColumn('string', 'Date');
      						data.addColumn('number', 'No of Reviews');

							responseData.forEach(function(entry) {
								data.addRow([entry['post_date'], parseInt(entry['reviews_nb'])]);
							});

							// Group the data

      						var newData = google.visualization.data.group(data, [{
						        column: 0,
						        type: 'Date'
						    }], [{
						        column: 1,
						        label: 'No of Reviews',
						        aggregation: google.visualization.data.sum,
						        type: 'number'
						    }]);

							
							var options = {
								chart: {
									title: 'No. of Image Reviews by Date',
									subtitle: 'for this product'
								},
								aggregation: google.visualization.data.sum
							};

							var chart = new google.charts.Line(document.getElementById('sp-product-chart'));
							chart.draw(newData, google.charts.Line.convertOptions(options));

							registerResize(function(height, width) {
	    						chart.draw(newData, google.charts.Line.convertOptions(options));
							});

							var reviewContainer = $('#sp_review_product_statistics');

							reviewContainer.on('click', 'h2, button', function(){
								var insideButton = reviewContainer.find('button');
								if ( insideButton.attr('aria-expanded') == 'true'  ) {
									chart.draw(newData, google.charts.Line.convertOptions(options));
								}
								
							});

						}
					}
					else {
						that.text('No statistics for this product.');
						that.css('height', 'auto');
					}
				}  
			});
		});
	}

	function triggers()
	{
		same_height( maincontainer.find(".sp_iw-section-dashboard-row") );
        make_tabs();

        user_get_charts();
        product_get_charts();
		
		$('body').on('click', ".sp-tmdb-auth-box-header a:not(.on)", function(e){
			e.preventDefault();
			var that = $(this),
				rel = $(that.attr('href')),
				preload = $(".sp-tmdb-auth-containers .sp_iw-loader");
				
			preload.show();
			
			$(".sp-tmdb-auth-box-header a.on").removeClass("on");
			$(".sp-tmdb-tab-auth").hide();
			rel.show();
			
			if( that.attr('href') == '#sp-tmdb-auth-tab-user' ){
				$.ajax({
					url: ajaxurl,
					dataType: "json",
					method: 'post',
					data: {
						action: 'sp_Envato_ajax',
						sub_action: "get_account"
					},
					// Handle the successful result
					success: function( response ) {
						if( response.status == 'valid' ){
							rel.html( response.html ); 
							preload.hide();
						}
					}
				});
				
			}
			else{
				preload.hide();
			}
			that.addClass('on');
		});
		
		if( $('.sp-tmdb-auth-box-header').data('default') == 'ok' ){
			$('.sp-tmdb-auth-box-header a').eq(1).click();
		}else{
			$('.sp-tmdb-auth-box-header a').eq(0).click();
		}
		
		$('body').on('click', 'button.sp-add-btn', function(e){
			e.preventDefault();
			add_product( $(this) );
		});
		
		$('body').on('click', '#sp-search-on-amazon, .sp-items-pagination button, .sp-find-product-by-id', function(e){
			e.preventDefault();
			
			var that = $(this),
				type = 'keyword';
			
			if( that.hasClass("sp-find-product-by-id") ){
				type = 'asin';
			}
			 
			launch_amazon_search( that, type );
		});

		// Pagination links, sortable link
		maincontainer.find('.tablenav-pages a, .manage-column.sortable a, .manage-column.sorted a').on('click', function(e) {
			e.preventDefault();
			
			// use the URL to extract our needed variables
			var query = this.search.substring( 1 );
			
			var data = {
				paged: __query( query, 'paged' ) || '1',
				order: __query( query, 'order' ) || 'desc',
				orderby: __query( query, 'orderby' ) || 'id'
			};
  
			update( data );
		});

		// page number input
		maincontainer.find('input[name=paged]').on('keyup', function(e) {

			// If user hit enter, we don't want to submit the form
			if ( 13 == e.which )
				e.preventDefault();

			// This time we fetch the variables in inputs
			var data = {
				paged: parseInt( maincontainer.find('input[name=paged]').val() ) || '1',
				order: maincontainer.find('input[name=order]').val() || 'desc',
				orderby: maincontainer.find('input[name=orderby]').val() || 'id',
				filter_by: maincontainer.find('input[name=filter_by]').val() || 'post',
			};
 
			update( data );
		});
		
		maincontainer.find('select[name=filter_by]').on('change', function(e) {
			var that = $(this),
				val = that.val();
			
			maincontainer.find('select[name=filter_by]').val( val ); 
		});
		
		// bulk actions - Apply
        maincontainer.find('input#doaction').on('click', function(e) {
            e.preventDefault();
            
            var that = $(this),
                form = that.parents('form').eq(0),
                _action = form.find('select#bulk-action-selector-top').val();
 
            // '_ajax_custom_list_nonce', 'ajaxid', 'order', 'orderby', '_wpnonce', '_wp_http_referer'
            var field_reset = ['_ajax_custom_list_nonce', 'ajaxid', 'order', 'orderby', '_wp_http_referer'];
            for (var i in field_reset) {
                $( 'input[name="'+field_reset[i]+'"]' ).remove();
            }
            if ( 'delete' == _action ) {
                $( 'input[name="paged"]' ).val(1);
            }
  
            form.submit();
        });
		
		$('.sp-wp-color-picker').wpColorPicker();
		
        $('body').on('click', '.sp-saveOptions', function(e) {
            e.preventDefault();
            saveOptions( $(this) );
        });
        
        maincontainer.find('#sp-tmdb-auth-button').on('click', function(e) {
        	e.preventDefault();
        	
        	tmdb_auth( $(this) ); 
        });
        
        $('body').on('click', '.sp-show-all-options', function(e) {
            e.preventDefault();
            
            var that = $(this).parents('form').eq(0);
            
            that.find(".we-complex-options").removeClass('we-complex-options');
        });

        maincontainer.find('.sp_iw-register_plugin').on('click', '.sp_iw-dashboard-button', function(e) {
        	e.preventDefault();

        	register_plugin( $(this) );
        });

        maincontainer.on('click', '.sp_iw-require_register', function(e){
        	e.preventDefault();

        	$(".sp_iw-dashboard-input[name='sp_iw-validation-token']").focus();
        });

        maincontainer.find('.sp-select-wrapper').on('click', '.sp-select-item:not(.select-on)', function(e) {
        	e.preventDefault();

        	var that = $(this),
        		parent = that.parent();

        	parent.find(".select-on").removeClass('select-on');
        	parent.find("input").removeAttr("checked");

        	that.addClass('select-on');
        	that.find("input").prop('checked', true);
        });

        font_preview();
	}
	
    var misc = {
        is_chrome: function() {
            return window.chrome;
        }
    }

	// external usage
	return {
		'triggers'                  : triggers,
        'make_tabs'                  : make_tabs
	}
})(jQuery);
